#include <stdio.h>
#include <stdlib.h>
#include <orb/orbit.h>
#include "tm.h"

int main (int argc, char *argv[]){
  CORBA_ORB orb;
  TM_TMPD tmpd_client;
  TM_protocols *p;
  CORBA_Environment ev;
  FILE * ifp;
  char * ior;
  char buffer[1024];
  CORBA_exception_init(&ev);
  orb = CORBA_ORB_init(&argc, argv, "orbit-local-orb", &ev);
  strcpy(buffer,g_get_home_dir());
  strcat(buffer, "/.tm/tmpd.ior");
  ifp = fopen(buffer,"r");
  if( ifp == NULL ) {
    g_error("No ~/.tm/tmpd.ior file!\n");
    exit(-1);
  }
  fgets(buffer,1024,ifp);
  ior = g_strdup(buffer);
  tmpd_client = CORBA_ORB_string_to_object(orb, ior, &ev);
  if (!tmpd_client || ev._major != CORBA_NO_EXCEPTION) {
    g_print("Cannot bind to %s\n", ior);
    return 1;
  }
  g_print("Trying to get a new http object.\n");
  TM_TMPD_get_new_protocol(tmpd_client, "http", &ev);
  if(ev._major != CORBA_NO_EXCEPTION) {
    g_print("Exception thrown: %s\n", CORBA_exception_id (&ev));
  }
  g_print("Trying to get a new ftp object.\n");
  TM_TMPD_get_new_protocol(tmpd_client, "ftp", &ev);
  if(ev._major != CORBA_NO_EXCEPTION) {
    g_print("Exception thrown: %s\n", CORBA_exception_id (&ev));
  }
  g_print("Requesting a list of protocols.\n");
  p=TM_TMPD_get_protocols(tmpd_client, &ev);
  if(ev._major != CORBA_NO_EXCEPTION) {
    g_print("Exception thrown: %s\n", CORBA_exception_id (&ev));
  }
  if (tmpd_client != CORBA_OBJECT_NIL)
    CORBA_Object_release(tmpd_client, &ev);
  if (orb != CORBA_OBJECT_NIL)
    CORBA_Object_release((CORBA_Object)orb, &ev);
  CORBA_exception_free (&ev);
  return 0;
}
